/* -- Google fonts -- */
@import url('https://fonts.googleapis.com/css?family=Inconsolata:400,700|Open+Sans:300,300i,400,400i,600,600i,700,700i,800,800i&display=swap');

:root {
  --base-font-size: 14.5rem;
  --small-font-size: 13.25rem;
  --large-font-size: 16rem;
  --line-height: 1.5em;
  --big-line-height: 1.8em;
  --small-line-height: 1.2em;
  --sans-font: 'Open Sans', sans-serif;
  --monospace-font: 'Inconsolata';

  --primary-color: var(--color-dark-cornflower-blue-2);
  --box-border-color: var(--color-dark-gray-2);
  --heading-color: var(--primary-color);
}

html {
  font-size: 1px; /* base rem size */
}

body {
  font-size: var(--base-font-size);
  line-height: var(--line-height);
  font-family: var(--sans-font);
  overflow-x: auto;
}

/* --| Responsive classes |------------------------------------------------- */

.s1, .s2, .s3, .s4, .s5, .s6, .s7, .s8, .s9, .s10, .s11, .s12,
.m1, .m2, .m3, .m4, .m5, .m6, .m7, .m8, .m9, .m10, .m11, .m12,
.l1, .l2, .l3, .l4, .l5, .l6, .l7, .l8, .l9, .l10, .l11, .l12,
.xl1, .xl2, .xl3, .xl4, .xl5, .xl6, .xl7, .xl8, .xl9, .xl10, .xl11, .xl12 {
  box-sizing: border-box;
}

.row > * {
  float: left;
  box-sizing: border-box;
  min-height: 1px;
  margin-left: 0.75em;
  margin-right: 0.75em;
}
.row:after {
  content: "";
  display: table;
  clear: both;
}

/* small-and-up */
@media only screen and (min-width: 0px) {
  .s12 {width: calc(100% * (12/12))}
  .s11 {width: calc(100% * (11/12))}
  .s10 {width: calc(100% * (10/12))}
  .s9  {width: calc(100% * ( 9/12))}
  .s8  {width: calc(100% * ( 8/12))}
  .s7  {width: calc(100% * ( 7/12))}
  .s6  {width: calc(100% * ( 6/12))}
  .s5  {width: calc(100% * ( 5/12))}
  .s4  {width: calc(100% * ( 4/12))}
  .s3  {width: calc(100% * ( 3/12))}
  .s2  {width: calc(100% * ( 2/12))}
  .s1  {width: calc(100% * ( 1/12))}
  .narrated-code {flex-direction: column}
  .narrated-code.nowrap {flex-direction: row}
}

/* medium-and-up: */
@media only screen and (min-width: 601px) {
  .m12 {width: calc(100% * (12/12))}
  .m11 {width: calc(100% * (11/12))}
  .m10 {width: calc(100% * (10/12))}
  .m9  {width: calc(100% * ( 9/12))}
  .m8  {width: calc(100% * ( 8/12))}
  .m7  {width: calc(100% * ( 7/12))}
  .m6  {width: calc(100% * ( 6/12))}
  .m5  {width: calc(100% * ( 5/12))}
  .m4  {width: calc(100% * ( 4/12))}
  .m3  {width: calc(100% * ( 3/12))}
  .m2  {width: calc(100% * ( 2/12))}
  .m1  {width: calc(100% * ( 1/12))}
  .narrated-code {flex-direction: row}
}
/* large-and-up: */
@media only screen and (min-width : 993px)  {
  .l12 {width: calc(100% * (12/12))}
  .l11 {width: calc(100% * (11/12))}
  .l10 {width: calc(100% * (10/12))}
  .l9  {width: calc(100% * ( 9/12))}
  .l8  {width: calc(100% * ( 8/12))}
  .l7  {width: calc(100% * ( 7/12))}
  .l6  {width: calc(100% * ( 6/12))}
  .l5  {width: calc(100% * ( 5/12))}
  .l4  {width: calc(100% * ( 4/12))}
  .l3  {width: calc(100% * ( 3/12))}
  .l2  {width: calc(100% * ( 2/12))}
  .l1  {width: calc(100% * ( 1/12))}
}
/* extra-large: */
@media only screen and (min-width : 1201px)  {
  .xl12 {width: calc(100% * (12/12))}
  .xl11 {width: calc(100% * (11/12))}
  .xl10 {width: calc(100% * (10/12))}
  .xl9  {width: calc(100% * ( 9/12))}
  .xl8  {width: calc(100% * ( 8/12))}
  .xl7  {width: calc(100% * ( 7/12))}
  .xl6  {width: calc(100% * ( 6/12))}
  .xl5  {width: calc(100% * ( 5/12))}
  .xl4  {width: calc(100% * ( 4/12))}
  .xl3  {width: calc(100% * ( 3/12))}
  .xl2  {width: calc(100% * ( 2/12))}
  .xl1  {width: calc(100% * ( 1/12))}
}

/* small-and-down: */
@media only screen and (max-width : 600px)  {
  .med-and-up, .large-and-up {display: none}
}
/* medium-and-down: */
@media only screen and (max-width : 992px)  {
  .large-and-up {display: none}
}
/* large-and-down: */
@media only screen and (max-width : 992px)  {
}

/* small-only: */
@media only screen and (max-width : 600px)  {
  .large-only, .med-only .xl-only {display: none !important}
}
/* medium-only: */
@media only screen and (min-width : 601px) and (max-width : 992px)  {
  .small-only, .large-only, .xl-only {display: none !important}
}
/* large-only: */
@media only screen and (min-width : 993px) and (max-width : 1200px)  {
  .small-only, .med-only .xl-only {display: none !important}
}
/* xl-only */
@media only screen and (min-width : 1201px) {
  .small-only, .large-only, .med-only {display: none !important}
}

/* -------------------------------------------------------------------------- */

.block-center {
  display: block;
  margin: 0 auto;
}

.doctitle {
  display: none;
}

/**
 * Misc helper classes
 */

.hidden {
  display: none;
}

code.no-overflow {
  overflow-x: visible;
}
.flex {
  display: flex;
}

.justify-space-between {
  justify-content: space-between;
}

.flex-wrap {
  flex-wrap: wrap;
}

.pad-small {
  padding: 4px;
}

.pad-med {
  padding: 10px;
}

.pad-big {
  padding: 20px;
}

.align-center {
  align-items: center;
}

.center-text {
  text-align: center;
}

/* 
 * default properties for the chapter that can be overridden using variables 
 * within the chapter's style element
 */
.chapter, .page {
  line-height: var(--line-height);
  position: relative;
}

/* -- section headings --*/
section > h1:first-of-type {
  margin-top: 0;
}

h1, h2, h3, h4, h5, h6 {
  color: var(--heading-color);
  font-size: 1em;
  line-height: 1em;
}

h1, h2, h3 {
  font-weight: normal;
}

h1 {
  font-size: 1.8em;
}


h2 {
  margin-top: 1.5em;
  font-size: 1.2em;
}

h3 {
  font-size: 1em;
  font-weight: 600;
  font-style: italic;
}

/* -- paragraph text -- */
.chapter em.voc {
  font-weight: bold;
  font-style: normal;
  white-space: nowrap;
}

.nowrap {
  white-space: nowrap;
}

.delete {
  text-decoration: line-through;
}

.chapter a.btn {
  display: inline-block;
  padding: 10px;
  background: var(--color-cornflower-blue);
  border-radius: 10px; 
  box-shadow: 2px 2px 2px rgba(0, 0, 0, 0.15);
  color: white;
  text-decoration: none;
  font-weight: 600;
  cursor: pointer;
  user-select: none;
}

/* -- lists -- */
.chapter ol, .chapter ul {
  --bullet-width: 1.2em;
  list-style: none;
  padding-left: var(--bullet-width);
}
.chapter ol li, .chapter ul li {
  display: block;
  margin: .5em 0;
  position: relative;
}

.chapter ol li::before, .chapter ul li::before {
  position: absolute;
  display: block;
  font-weight: bold;
  width: var(--bullet-width);
  left: calc(var(--bullet-width) * -1);
}

.steps-counter, ol:not(.continue), ul:not(.continue) {
  counter-reset: steps;
}
.steps-counter ol {
  counter-reset: none;
}
.chapter ol li {
  counter-increment: steps;
}
.chapter ol li::before {
  content: counter(steps) ". ";
}

.chapter ol.deci {
  --bullet-width: 1.8em;
}

.chapter ol.indented {
  margin-left: 1em;
}

.chapter ol.line-descriptions {
  --bullet-width: 4.5em;
}
.chapter ol.line-descriptions li::before {
  content: "Line " attr(data-line) ":";
}

.chapter ul.indent {
  margin-left: 1em;
}
.chapter ul li::before {
  content: "●";
}

.chapter ul.pointers li::before {
  padding-right: 1em;
  content: "▶";
  font-size: .8em;
}

/* "narrated image" */
.narrated-image {
  display: flex;
}
.narrated-image > * {
  width: 50%;
  align-self: start;
}

/* -- code -- */
:root {
  --code-box-padding: 0.5em;
  --code-box-padding-right: var(--code-box-padding);
}
code {
  --code-border-width: 0px;
  font-family: var(--monospace-font);
  overflow-x: auto;
}
code.no-overflow {
  overflow-x: visible;
}
code:not(.allow-copy) {
  user-select: none;
}
code:not([class]) {
  /* for inline code block with no language specified */
  color: var(--color-dark-cornflower-blue-2);
}
code:not(.block) {
  /* prevent inline code from wrapping */
  white-space: nowrap;
}
code.outlined {
  /* for inline code that's outlined for emphasis */
  border: 1px solid var(--color-gray);
  border-radius: .1em;
  padding: 0 .5em;
}
code.block {
  margin: 1em 0;
  line-height: var(--line-height);
  --code-border-width: 1px;
  --white-space: normal;
  white-space: var(--white-space);
  display: block;
  align-self: start;
  border: var(--code-border-width) solid var(--box-border-color);
  padding: var(--code-box-padding);
  padding-right: var(--code-box-padding-right);
}

code .traceback, code .traceback * {
  /* Force all text in tracebacks to red */
  color: var(--color-light-red-berry-1) !important;
}

code[data-header]::before,
code[data-caption]::after,
code.skipped-lines::before {
  display: block;
  margin-left: calc(var(--code-box-padding) * -1);
  margin-right: calc(var(--code-box-padding-right) * -1);
  padding: 0 var(--code-box-padding);
  font-family: var(--sans-font);
  font-style: italic;
}
code[data-header]::before,
code.skipped-lines::before {
  border-bottom: 1px solid var(--box-border-color);
}
code[data-header]::before {
  content: attr(data-header);
  background: var(--color-light-gray-1);
}
code.skipped-lines {
  margin-top: calc(-1em - 1px);
}
code.skipped-lines::before {
  content: "- - -";
  text-align: center;
  background: var(--color-light-gray-3);
}
code.numbered[data-header]::before,
code.skipped-lines::before {
  margin-left: calc(var(--line-number-column-width) * -1);
  border-bottom: 1px solid var(--box-border-color);
}

code[data-caption]::after {
  --caption-padding: 4px;
  background: var(--color-light-gray-3);
  margin-left: calc(var(--code-box-padding) * -1);
  margin-right: calc(var(--code-box-padding-right) * -1);
  padding: var(--caption-padding);
  content: attr(data-caption);
  border-top: 1px solid var(--box-border-color);
  text-align: center;
}
code.numbered[data-caption]::after {
  margin-left: calc(var(--line-number-column-width) * -1);
}

.code-columns {
  display: flex;
}

/* "narrated code" block */
.narrated-code {
  --code-margin-right: var(--base-font-size);
  line-height: var(--line-height);
  margin: 1em 0;
  display: flex;
}
.narrated-code > * {
  margin: 0;
}
.narrated-code > code {
  margin: 0;
  margin-right: var(--code-margin-right);
  align-self: start;
  overflow-x: visible;
}
.narrated-code > code + * {
  padding: var(--code-box-padding);
  padding-left: 0;
}
.narrated-code > code + ol,
.narrated-code > code + ul {
  padding-left: calc(var(--code-box-padding) * 2);
}

.narrated-code > code + * ol,
.narrated-code > code + * ul,
.narrated-code > code + * li,
.narrated-code > code + * p {
  margin: 0;
  line-height: var(--line-height);
}
.narrated-code olcode + *,
.narrated-code ulcode + * {
  margin: 0;
}
.narrated-code > code + .spaced li {
  margin: 1em 0;
}
.narrated-code > code + .spaced li:first-child {
  margin-top: 0;
}
.narrated-code > code + .spaced li:last-child {
  margin-bottom: 0;
}
.narrated-code > code + * p {
  margin-bottom: var(--line-height);
}
.narrated-code > code + * > *:last-child {
  margin-bottom: 0 !important;
}
.narrated-code.under {
  display: block;
}
.narrated-code.under > code {
  margin-right: 0;
}
.narrated-code.under > code + * {
  margin-top: -1px;
  padding: .5em;
  border: 1px solid var(--box-border-color);
}
.narrated-code.under > code + * :first-child {
  margin-top: 0;
}
.narrated-code.under > code + * :last-child {
  margin-bottom: 0;
}
.narrated-code.aligned > code + * {
  position: relative;
  width: 100%;
}
.narrated-code.outlined > code + * {
  border: 1px solid var(--box-border-color);
  width: 100%;
  padding-left: .5em;
  padding-right: .5em;
  margin-left: -1rem;
}
.narrated-code.outlined > code {
  margin-right: 0;
  align-self: auto;
}
.narrated-code.code-header > code + * {
  margin-top: calc(1em + 2rem + var(--code-box-padding));
}

.narrated-code.outlined.result > code {
  padding-right: 15rem;
  box-shadow: 4px 0 8px -4px rgba(0, 0, 0, .25);
}
.narrated-code.result > code + * {
  --arrow-size: 30rem;
  position: relative;
  padding-left: calc(var(--arrow-size) + var(--code-box-padding));
  font-family: serif;
  font-size: 1.2em;
  padding-top: var(--code-box-padding);
  color: var(--color-dark-gray-3);
}
.narrated-code.result > code + *:before {
  content: "🠺";
  color: var(--color-orange);
  -webkit-text-stroke: 2.5rem white;
  display: block;
  position: absolute;
  font-size: calc(var(--arrow-size) * 2.1);
  width: var(--arrow-size);
  height: var(--arrow-size);
  left: calc(var(--arrow-size) * -.4);
  top: calc(50% - var(--arrow-size) / 2);
  display: flex;
  align-items: center;
}


/* Code blocks */
pre code, code.block {
  position: relative;
  padding-top: 0;
  padding-bottom: 0;
  white-space: normal;
}
code .hljs-line {
  white-space: pre;
  display: block;
  position: relative;
}
code .hljs-line:first-child::before {
  top: calc(var(--code-box-padding) * -1);
  padding-top: var(--code-box-padding);
}
code .hljs-line:last-child::before {
  bottom: calc(var(--code-box-padding) * -1);
  padding-bottom: var(--code-box-padding);
}
code .hljs-line.added {
  background-color: var(--color-light-green-3);
}
code .hljs-line.added .hljs-string {
  color: var(--color-dark-green-2);
}
code .hljs-line.removed {
  /* shrink div to fit contents */
  width: fit-content;
}
code .hljs-line.removed::after {
  position: absolute;
  content: "";
  border-top: 1px solid var(--color-dark-red-1);
  opacity: 50%;
  top: 50%;
  min-width: 8ch;
  width: 100%;
  left: 0;
}
code .hljs-line.em {
  --border-width: 2rem;
  --border-radius: 5rem;
  border-color: var(--color-red);
  border-width: var(--border-width);
  border-style: solid;
  border-top-width: 0;
  border-bottom-width: 0;
}
code .hljs-line.em-start {
  border-top-width: var(--border-width);
  border-top-left-radius: var(--border-radius);
  border-top-right-radius: var(--border-radius);
}
code .hljs-line.em-end {
  border-bottom-width: var(--border-width);
  border-bottom-left-radius: var(--border-radius);
  border-bottom-right-radius: var(--border-radius);
}
code .hljs-line.sep-after {
  border-bottom: 1px solid var(--color-light-grey-1);
}

/* Numbered code lines */
code.numbered {
  /* customizable settings */
  --line-number-chars: 1;
  --line-number-charwidth: .5em;
  --line-number-right-border-width: 1px;
  --line-number-right-border-color: var(--box-border-color);
  --line-number-bgcolor: var(--color-light-gray-3);
  --line-number-color: var(--color-dark-gray-2);

  /* calculated settings */
  --line-number-width: calc(var(--line-number-charwidth) * var(--line-number-chars));
  --line-number-padding: var(--code-box-padding);
  --line-number-column-width: calc(var(--line-number-padding) * 2 + var(--line-number-width) + var(--line-number-right-border-width) * 2); 
  padding-left: var(--line-number-column-width);
}
code .hljs-line.first {
  margin-top: var(--code-box-padding);
}
code .hljs-line.last {
  margin-bottom: var(--code-box-padding);
}
code.hljs-linenumber-size-2 {
  --line-number-chars: 2;
}
code.hljs-linenumber-size-3 {
  --line-number-chars: 3;
}
code.hljs-linenumber-size-4 {
  --line-number-chars: 4;
}
code.numbered {
  --code-box-padding: 0.3em;
}
code.numbered:not(.continue) {
  counter-reset: hljs-line-number;
}
code.numbered[data-line-start] {
  /* KLUDGE: we can't actually use attr here, so it must be done in js */
  counter-reset: hljs-line-number attr(data-line-start);
}
code.numbered .hljs-line {
  padding-left: var(--code-box-padding);
  counter-increment: hljs-line-number; 
}
code.numbered .hljs-line::before {
  content: counter(hljs-line-number);
  position: absolute;
  display: block;
  top: 0; bottom: 0;
  left: calc(var(--code-border-width) + var(--line-number-column-width) * -1);
  min-width: var(--line-number-width);
  text-align: right;
  padding: 0 var(--line-number-padding);
  border-right: var(--line-number-right-border-width) solid var(--box-border-color);
  background: var(--line-number-bgcolor);
  color: var(--line-number-color);
}
code.numbered .hljs-line:first-child::before {
  top: calc(var(--code-box-padding) * -1);
  padding-top: var(--code-box-padding);
}
code.numbered .hljs-line:last-child::before {
  bottom: calc(var(--code-box-padding) * -1);
  padding-bottom: var(--code-box-padding);
}

/**
 * I/O prompts similar to chrome console
 */
.language-javascript.console {
  --prompt-size: .8em;
  --prompt-padding: .4em;
}
.language-javascript.console .hljs-output {
  --prompt-color: var(--color-dark-gray-1);
}
.language-javascript.console .hljs-input {
  --prompt-color: var(--color-dark-blue-1);
}
.language-javascript.console .hljs-input .input-prompt {
  color: var(--prompt-color);
  font-weight: bold;
}
.language-javascript.console .hljs-output .output-prompt {
  color: var(--prompt-color);
  font-weight: bold;
}
.language-javascript.console .hljs-error .error-prompt {
  --prompt-color: red;
  color: var(--prompt-color);
  font-weight: bold;
}
.language-javascript.console .hljs-output .output-prompt,
.language-javascript.console .hljs-input .input-prompt,
.language-javascript.console .hljs-error .error-prompt {
  text-indent: 100%;
  white-space: nowrap;
  overflow: hidden;
  width: var(--prompt-size);
  height: var(--prompt-size);
  display: inline-block;
  margin-right: var(--prompt-padding);
}
.language-javascript.console .hljs-input .input-prompt {
  background-color: var(--prompt-color);
  --icon: url("data:image/svg+xml,%3Csvg width='8' height='8' xmlns='http://www.w3.org/2000/svg'%3E%3Cpath d='M1 1l3.5 3.25L1 7.5' stroke='%23666' stroke-width='1.5' fill='none' fill-rule='evenodd'/%3E%3C/svg%3E") right bottom / 100% no-repeat;
  mask: var(--icon);
  -webkit-mask: var(--icon);
}
.language-javascript.console .hljs-output .output-prompt {
  background-color: var(--prompt-color);
  --icon: url("data:image/svg+xml,%3Csvg width='8' height='8' xmlns='http://www.w3.org/2000/svg'%3E%3Cg fill='none' fill-rule='evenodd'%3E%3Cpath d='M6 4c0 .55.45 1 1 1s1-.45 1-1-.45-1-1-1-1 .45-1 1' fill='%23BABABA'/%3E%3Cpath d='M5.25.75L1.75 4l3.5 3.25' stroke='%23BABABA' stroke-width='1.5'/%3E%3C/g%3E%3C/svg%3E") left bottom / 100% no-repeat;
  mask: var(--icon);
  -webkit-mask: var(--icon);
}
.language-javascript.console .hljs-error {
  background: #ffefef;
}
.language-javascript.console .hljs-error,
.language-javascript.console .hljs-error span {
  color: #f44337;
}
.language-javascript.console .hljs-error .error-prompt {
  background-color: var(--prompt-color);
  --icon: url("data:image/svg+xml,%3C%3Fxml version='1.0' encoding='UTF-8' standalone='no'%3F%3E%3Csvg xmlns:dc='http://purl.org/dc/elements/1.1/' xmlns:cc='http://creativecommons.org/ns%23' xmlns:rdf='http://www.w3.org/1999/02/22-rdf-syntax-ns%23' xmlns:svg='http://www.w3.org/2000/svg' xmlns='http://www.w3.org/2000/svg' xmlns:sodipodi='http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd' xmlns:inkscape='http://www.inkscape.org/namespaces/inkscape' width='10px' height='10px' viewBox='0 0 10 10' version='1.1' id='svg13' sodipodi:docname='error.svg' inkscape:version='1.0.1 (3bc2e813f5, 2020-09-07)'%3E%3Cmetadata id='metadata17'%3E%3Crdf:RDF%3E%3Ccc:Work rdf:about=''%3E%3Cdc:format%3Eimage/svg+xml%3C/dc:format%3E%3Cdc:type rdf:resource='http://purl.org/dc/dcmitype/StillImage' /%3E%3Cdc:title%3EGroup%3C/dc:title%3E%3C/cc:Work%3E%3C/rdf:RDF%3E%3C/metadata%3E%3Csodipodi:namedview pagecolor='%23ffffff' bordercolor='%23666666' borderopacity='1' objecttolerance='10' gridtolerance='10' guidetolerance='10' inkscape:pageopacity='0' inkscape:pageshadow='2' inkscape:window-width='2560' inkscape:window-height='1417' id='namedview15' showgrid='false' inkscape:zoom='51.3' inkscape:cx='8.8841823' inkscape:cy='3.6777891' inkscape:window-x='1920' inkscape:window-y='23' inkscape:window-maximized='1' inkscape:current-layer='svg13' /%3E%3C!-- Generator: Sketch 3.6.1 (26313) - http://www.bohemiancoding.com/sketch --%3E%3Ctitle id='title2'%3EGroup%3C/title%3E%3Cdesc id='desc4'%3ECreated with Sketch.%3C/desc%3E%3Cdefs id='defs6' /%3E%3Cpath id='path3701' style='fill:%23000000;fill-rule:evenodd;stroke:none;stroke-width:1.06623' d='m 4.9746323,0.07741756 c -2.7295358,0 -4.94795006,2.21841424 -4.94795006,4.94795014 0,2.7295358 2.21841426,4.9479501 4.94795006,4.9479501 2.7295359,0 4.9479501,-2.2184143 4.9479501,-4.9479501 0,-2.7295359 -2.2184142,-4.94795014 -4.9479501,-4.94795014 z m -1.765935,2.43649054 1.765935,1.765935 1.7659351,-1.765935 0.7455245,0.7455245 -1.765935,1.7659351 1.765935,1.765935 L 6.7405674,7.5368273 4.9746323,5.7708922 3.2086973,7.5368273 2.4631727,6.7913027 4.2291078,5.0253677 2.4631727,3.2594326 Z' /%3E%3C/svg%3E%0A") left bottom / 100% no-repeat;
  mask: var(--icon);
  -webkit-mask: var(--icon);
}
.language-javascript.console .hljs-log {
  padding-left: calc(var(--prompt-size) + var(--prompt-padding));
}
.language-javascript.console[data-caption]::after {
  margin-left: calc(var(--code-box-padding) * -1);
}

/* "code steps" (like a .steps ol, but with outlined code) */
ol.code-steps {
  position: relative;
}
/* simulate code box padding */
ol.code-steps li {
  padding: 0 var(--code-box-padding);
}
ol.code-steps li:first-child {
  padding-top: var(--code-box-padding);
}
ol.code-steps li:last-child {
  padding-bottom: var(--code-box-padding);
}
ol.code-steps::after {
  /* border for code */
  content: "";
  display: block;
  position: absolute;
  left: var(--bullet-width);
  right: 0;
  top: 0;
  bottom: 0;
  border: 1px solid var(--box-border-color);
}
ol.code-steps li::before {
  padding-right: .5em;
}

/* -- images -- */
img {
  max-width: 100%;
}
img.float-right {
  float: right;
  padding-left: 10rem;
}
img.float-left {
  float: left;
  padding-right: 10rem;
}
img.float-right:after,
img.float-left:after {
  content: "";
  display: table;
  clear: both;
}

.clearfloat: {
  clear: both;
}

/* -- table -- */
table {
  font-size: inherit;
}
table.table {
  border-spacing: 0;
  border-collapse: collapse;
}
table.table th, table.table td {
  border: 1px solid var(--box-border-color);
  padding: .4em;
}
table.table thead th {
  background-color: var(--color-dark-gray-1);
  color: white;
}
table.table tbody th,
table.table.first-column-header tr td:first-child {
  background-color: var(--color-light-gray-2);
  text-align: left;
}
table.table.noheader thead {
  display: none;
}

/* -- dodads --*/
.infobox {
  --icon-size: 30rem;
  --padding: 10rem;
  position: relative;
  border: 1rem solid var(--box-border-color);
  padding: var(--padding);
  padding-left: calc(var(--padding) + var(--padding) + var(--icon-size));
  margin: 1em 0;
}
.infobox::before {
  position: absolute;
  left: var(--padding); 
  top: 0;
  bottom: 0;
  right: calc(100% - var(--icon-size) - var(--padding));
  display: block;
  content: "";
  background-repeat: no-repeat;
  background-size: var(--icon-size) var(--icon-size);
  background-position: left center; /* older browsers */
  background-position: 0px min(1em, 50%);
  background-image: url(../images/icon-info.png);
}
.infobox.question::before {
  background-image: url(../images/icon-question.png);
}
.infobox.warning::before {
  background-image: url(../images/icon-warning.png);
}
/*
.infobox.stop::before {
  background-image: url(../images/icon-stop.png);
}
*/
.infobox.find::before {
  background-image: url(../images/icon-search.png);
}

/* remove leading/trailing margins from content */
.infobox > :first-child {
  margin-top: 0;
}
.infobox > :last-child {
  margin-bottom: 0;
}

.big-infobox {
  --icon-size: 25rem;
  --padding: 10rem;
  border: 1px solid var(--box-border-color);
  border-radius: 5rem;
  padding: var(--padding);
}
.big-infobox :last-child {
  margin-bottom: 0;
}
.big-infobox h1 {
  overflow: visible;
  font-size: 1.2em;
  line-height: var(--icon-size);
  vertical-align: middle;
  margin-bottom: 0;
  position: relative;
  padding-left: calc(var(--padding) + var(--icon-size));
}
.big-infobox h1::before {
  position: absolute;
  width: var(--icon-size);
  height: var(--icon-size);
  margin-top: calc(0 - var(--icon-size) - 10rem);
  left: 0; top: 0;
  display: block;
  content: "";
  background-repeat: no-repeat;
  background-size: var(--icon-size) var(--icon-size);
  background-image: url(../images/icon-info.png);
}
.big-infobox.question h1::before {
  background-image: url(../images/icon-question.png);
}
.big-infobox.warning h1::before {
  background-image: url(../images/icon-warning.png);
}

/* for emergencies only */
.overflow {
  margin-right: -20rem !important;
}

/* UL task lists */
ul.contains-task-list {
  padding-left: 0;
  --bullet-width: 0;
}
ul.contains-task-list li:before {
  display: none;
}


body.paged .infobox.page-align-bottom {
  position: absolute;
  bottom: 0;
  width: 100%;
  margin-bottom: 0px;
}

.nowrap {
  white-space: nowrap;
}

kbd {
	padding: 0.1em 0.6em;
	border: 1px solid #ccc;
	background-color: #f7f7f7;
  font-size: 0.8em;
	color: #333;
	box-shadow: 0 1rem 0rem rgba(0, 0, 0, 0.2),0 0 0 2rem #ffffff inset;
	border-radius: 3rem;
	margin: 0 0.1em;
	text-shadow: 0 1rem 0 #fff;
	line-height: 1.4em;
	white-space: nowrap;
  height: 1em;
}
kbd[data-glyph] {
  height: 1em;
}
kbd[data-glyph]:before {
  content: attr(data-glyph);
  font-size: 2em;
  vertical-align: text-bottom;
}

.arrow-curve {
  pointer-events: none;
  --color: var(--color-red);
  --width: 3px;
}

.arrow-curve__path {
  stroke: var(--color);
  fill: transparent;
  stroke-dasharray: 4 2;
  stroke-width: var(--width);
}

.arrow-curve__head line {
  stroke: var(--color);
  stroke-width: var(--width);
}

/**
 * Modal Popups
 */
.modal-container {
  position: fixed; /* Stay in place */
  z-index: 1; /* Sit on top */
  left: 0;
  top: 0;
  width: 100%; /* Full width */
  height: 100%; /* Full height */
  overflow: auto; /* Enable scroll if needed */
  background-color: rgb(0,0,0); /* Fallback color */
  background-color: rgba(0,0,0,0.4); /* Black w/ opacity */
  text-align: center;
}
.modal-container:not(.active) {
  display: none; /* Hidden by default */
}
.modal {
  background: #fff;
  margin: 15% auto; /* 15% from the top and centered */
  padding: 10px;
  border: 1px solid #888;
  width: auto;
  display: inline-block;
  /*width: 80%; /* Could be more or less, depending on screen size */
}
.modal-close {
  margin-bottom: 1em;
  text-align: right;
}
.modal-close button {
  cursor: pointer;
}
.modal > h1:first-of-type,
.modal > h2:first-of-type {
  margin-top: -1em;
}

/**
 * screen-only styles
 */
@media screen {
  .chapter:not(.active) {
    display: none;
  }

  .print-only {
    display: none;
  }

}
